<?php

namespace Proxies;

/**
 * THIS CLASS WAS GENERATED BY THE DOCTRINE ORM. DO NOT EDIT THIS FILE.
 */
class EntitiesActionProxy extends \Entities\Action implements \Doctrine\ORM\Proxy\Proxy
{
    private $_entityPersister;
    private $_identifier;
    public $__isInitialized__ = false;
    public function __construct($entityPersister, $identifier)
    {
        $this->_entityPersister = $entityPersister;
        $this->_identifier = $identifier;
    }
    /** @private */
    public function __load()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            if ($this->_entityPersister->load($this->_identifier, $this) === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            unset($this->_entityPersister, $this->_identifier);
        }
    }
    
    
    public function id()
    {
        $this->__load();
        return parent::id();
    }

    public function origId()
    {
        $this->__load();
        return parent::origId();
    }

    public function course(\Entities\Course $course = NULL)
    {
        $this->__load();
        return parent::course($course);
    }

    public function teacher(\Entities\Teacher $teacher = NULL)
    {
        $this->__load();
        return parent::teacher($teacher);
    }

    public function date($date = NULL)
    {
        $this->__load();
        return parent::date($date);
    }

    public function room($room = NULL)
    {
        $this->__load();
        return parent::room($room);
    }

    public function name($name = NULL)
    {
        $this->__load();
        return parent::name($name);
    }

    public function note($note = NULL)
    {
        $this->__load();
        return parent::note($note);
    }

    public function addStudent(\Entities\Student $student)
    {
        $this->__load();
        return parent::addStudent($student);
    }

    public function students()
    {
        $this->__load();
        return parent::students();
    }


    public function __sleep()
    {
        return array('__isInitialized__', 'id', 'orig_id', 'course_code', 'course', 'teacher', 'type', 'date', 'room', 'name', 'note', 'students');
    }

    public function __clone()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            $class = $this->_entityPersister->getClassMetadata();
            $original = $this->_entityPersister->load($this->_identifier);
            if ($original === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            foreach ($class->reflFields AS $field => $reflProperty) {
                $reflProperty->setValue($this, $reflProperty->getValue($original));
            }
            unset($this->_entityPersister, $this->_identifier);
        }
        
    }
}